# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyBypassCacheOnRequestHeader do
  @moduledoc """
  Bypass the cache when the specified request headers are present, e.g. Pragma or Authorization headers. Values are case insensitive. The presence of such a header overrides the cache_mode setting.

  ## Attributes

  *   `headerName` (*type:* `String.t`, *default:* `nil`) - The header field name to match on when bypassing cache. Values are case-insensitive.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :headerName => String.t() | nil
        }

  field(:headerName)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyBypassCacheOnRequestHeader do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyBypassCacheOnRequestHeader.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.BackendBucketCdnPolicyBypassCacheOnRequestHeader do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
