# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.DistributionPolicy do
  @moduledoc """


  ## Attributes

  *   `targetShape` (*type:* `String.t`, *default:* `nil`) - The distribution shape to which the group converges either proactively or on resize events (depending on the value set in updatePolicy.instanceRedistributionType).
  *   `zones` (*type:* `list(GoogleApi.Compute.V1.Model.DistributionPolicyZoneConfiguration.t)`, *default:* `nil`) - Zones where the regional managed instance group will create and manage its instances.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :targetShape => String.t() | nil,
          :zones => list(GoogleApi.Compute.V1.Model.DistributionPolicyZoneConfiguration.t()) | nil
        }

  field(:targetShape)
  field(:zones, as: GoogleApi.Compute.V1.Model.DistributionPolicyZoneConfiguration, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.DistributionPolicy do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.DistributionPolicy.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.DistributionPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
