# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.FirewallPoliciesListAssociationsResponse do
  @moduledoc """


  ## Attributes

  *   `associations` (*type:* `list(GoogleApi.Compute.V1.Model.FirewallPolicyAssociation.t)`, *default:* `nil`) - A list of associations.
  *   `kind` (*type:* `String.t`, *default:* `compute#firewallPoliciesListAssociationsResponse`) - [Output Only] Type of firewallPolicy associations. Always compute#FirewallPoliciesListAssociations for lists of firewallPolicy associations.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :associations => list(GoogleApi.Compute.V1.Model.FirewallPolicyAssociation.t()) | nil,
          :kind => String.t() | nil
        }

  field(:associations, as: GoogleApi.Compute.V1.Model.FirewallPolicyAssociation, type: :list)
  field(:kind)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.FirewallPoliciesListAssociationsResponse do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.FirewallPoliciesListAssociationsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.FirewallPoliciesListAssociationsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
