# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.GuestAttributes do
  @moduledoc """
  A guest attributes entry.

  ## Attributes

  *   `kind` (*type:* `String.t`, *default:* `compute#guestAttributes`) - [Output Only] Type of the resource. Always compute#guestAttributes for guest attributes entry.
  *   `queryPath` (*type:* `String.t`, *default:* `nil`) - The path to be queried. This can be the default namespace ('') or a nested namespace ('\\/') or a specified key ('\\/\\').
  *   `queryValue` (*type:* `GoogleApi.Compute.V1.Model.GuestAttributesValue.t`, *default:* `nil`) - [Output Only] The value of the requested queried path.
  *   `selfLink` (*type:* `String.t`, *default:* `nil`) - [Output Only] Server-defined URL for this resource.
  *   `variableKey` (*type:* `String.t`, *default:* `nil`) - The key to search for.
  *   `variableValue` (*type:* `String.t`, *default:* `nil`) - [Output Only] The value found for the requested key.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :kind => String.t() | nil,
          :queryPath => String.t() | nil,
          :queryValue => GoogleApi.Compute.V1.Model.GuestAttributesValue.t() | nil,
          :selfLink => String.t() | nil,
          :variableKey => String.t() | nil,
          :variableValue => String.t() | nil
        }

  field(:kind)
  field(:queryPath)
  field(:queryValue, as: GoogleApi.Compute.V1.Model.GuestAttributesValue)
  field(:selfLink)
  field(:variableKey)
  field(:variableValue)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.GuestAttributes do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.GuestAttributes.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.GuestAttributes do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
