# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.HttpHeaderAction do
  @moduledoc """
  The request and response header transformations that take effect before the request is passed along to the selected backendService.

  ## Attributes

  *   `requestHeadersToAdd` (*type:* `list(GoogleApi.Compute.V1.Model.HttpHeaderOption.t)`, *default:* `nil`) - Headers to add to a matching request before forwarding the request to the backendService.
  *   `requestHeadersToRemove` (*type:* `list(String.t)`, *default:* `nil`) - A list of header names for headers that need to be removed from the request before forwarding the request to the backendService.
  *   `responseHeadersToAdd` (*type:* `list(GoogleApi.Compute.V1.Model.HttpHeaderOption.t)`, *default:* `nil`) - Headers to add the response before sending the response back to the client.
  *   `responseHeadersToRemove` (*type:* `list(String.t)`, *default:* `nil`) - A list of header names for headers that need to be removed from the response before sending the response back to the client.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :requestHeadersToAdd => list(GoogleApi.Compute.V1.Model.HttpHeaderOption.t()) | nil,
          :requestHeadersToRemove => list(String.t()) | nil,
          :responseHeadersToAdd => list(GoogleApi.Compute.V1.Model.HttpHeaderOption.t()) | nil,
          :responseHeadersToRemove => list(String.t()) | nil
        }

  field(:requestHeadersToAdd, as: GoogleApi.Compute.V1.Model.HttpHeaderOption, type: :list)
  field(:requestHeadersToRemove, type: :list)
  field(:responseHeadersToAdd, as: GoogleApi.Compute.V1.Model.HttpHeaderOption, type: :list)
  field(:responseHeadersToRemove, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.HttpHeaderAction do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.HttpHeaderAction.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.HttpHeaderAction do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
