# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.HttpHeaderOption do
  @moduledoc """
  Specification determining how headers are added to requests or responses.

  ## Attributes

  *   `headerName` (*type:* `String.t`, *default:* `nil`) - The name of the header.
  *   `headerValue` (*type:* `String.t`, *default:* `nil`) - The value of the header to add.
  *   `replace` (*type:* `boolean()`, *default:* `nil`) - If false, headerValue is appended to any values that already exist for the header. If true, headerValue is set for the header, discarding any values that were set for that header. The default value is false. 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :headerName => String.t() | nil,
          :headerValue => String.t() | nil,
          :replace => boolean() | nil
        }

  field(:headerName)
  field(:headerValue)
  field(:replace)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.HttpHeaderOption do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.HttpHeaderOption.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.HttpHeaderOption do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
