# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.InstanceGroupManagerAutoHealingPolicy do
  @moduledoc """


  ## Attributes

  *   `healthCheck` (*type:* `String.t`, *default:* `nil`) - The URL for the health check that signals autohealing.
  *   `initialDelaySec` (*type:* `integer()`, *default:* `nil`) - The number of seconds that the managed instance group waits before it applies autohealing policies to new instances or recently recreated instances. This initial delay allows instances to initialize and run their startup scripts before the instance group determines that they are UNHEALTHY. This prevents the managed instance group from recreating its instances prematurely. This value must be from range [0, 3600].
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :healthCheck => String.t() | nil,
          :initialDelaySec => integer() | nil
        }

  field(:healthCheck)
  field(:initialDelaySec)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.InstanceGroupManagerAutoHealingPolicy do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.InstanceGroupManagerAutoHealingPolicy.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.InstanceGroupManagerAutoHealingPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
