# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.InstanceGroupManagerStatusStateful do
  @moduledoc """


  ## Attributes

  *   `hasStatefulConfig` (*type:* `boolean()`, *default:* `nil`) - [Output Only] A bit indicating whether the managed instance group has stateful configuration, that is, if you have configured any items in a stateful policy or in per-instance configs. The group might report that it has no stateful config even when there is still some preserved state on a managed instance, for example, if you have deleted all PICs but not yet applied those deletions.
  *   `perInstanceConfigs` (*type:* `GoogleApi.Compute.V1.Model.InstanceGroupManagerStatusStatefulPerInstanceConfigs.t`, *default:* `nil`) - [Output Only] Status of per-instance configs on the instance.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :hasStatefulConfig => boolean() | nil,
          :perInstanceConfigs =>
            GoogleApi.Compute.V1.Model.InstanceGroupManagerStatusStatefulPerInstanceConfigs.t()
            | nil
        }

  field(:hasStatefulConfig)

  field(:perInstanceConfigs,
    as: GoogleApi.Compute.V1.Model.InstanceGroupManagerStatusStatefulPerInstanceConfigs
  )
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.InstanceGroupManagerStatusStateful do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.InstanceGroupManagerStatusStateful.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.InstanceGroupManagerStatusStateful do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
