# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.InterconnectCircuitInfo do
  @moduledoc """
  Describes a single physical circuit between the Customer and Google. CircuitInfo objects are created by Google, so all fields are output only.

  ## Attributes

  *   `customerDemarcId` (*type:* `String.t`, *default:* `nil`) - Customer-side demarc ID for this circuit.
  *   `googleCircuitId` (*type:* `String.t`, *default:* `nil`) - Google-assigned unique ID for this circuit. Assigned at circuit turn-up.
  *   `googleDemarcId` (*type:* `String.t`, *default:* `nil`) - Google-side demarc ID for this circuit. Assigned at circuit turn-up and provided by Google to the customer in the LOA.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :customerDemarcId => String.t() | nil,
          :googleCircuitId => String.t() | nil,
          :googleDemarcId => String.t() | nil
        }

  field(:customerDemarcId)
  field(:googleCircuitId)
  field(:googleDemarcId)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.InterconnectCircuitInfo do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.InterconnectCircuitInfo.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.InterconnectCircuitInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
