# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.License do
  @moduledoc """
  Represents a License resource. A License represents billing and aggregate usage data for public and marketplace images. *Caution* This resource is intended for use only by third-party partners who are creating Cloud Marketplace images. 

  ## Attributes

  *   `chargesUseFee` (*type:* `boolean()`, *default:* `nil`) - [Output Only] Deprecated. This field no longer reflects whether a license charges a usage fee.
  *   `creationTimestamp` (*type:* `String.t`, *default:* `nil`) - [Output Only] Creation timestamp in RFC3339 text format.
  *   `description` (*type:* `String.t`, *default:* `nil`) - An optional textual description of the resource; provided by the client when the resource is created.
  *   `id` (*type:* `String.t`, *default:* `nil`) - [Output Only] The unique identifier for the resource. This identifier is defined by the server.
  *   `kind` (*type:* `String.t`, *default:* `compute#license`) - [Output Only] Type of resource. Always compute#license for licenses.
  *   `licenseCode` (*type:* `String.t`, *default:* `nil`) - [Output Only] The unique code used to attach this license to images, snapshots, and disks.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Name of the resource. The name must be 1-63 characters long and comply with RFC1035.
  *   `resourceRequirements` (*type:* `GoogleApi.Compute.V1.Model.LicenseResourceRequirements.t`, *default:* `nil`) - 
  *   `selfLink` (*type:* `String.t`, *default:* `nil`) - [Output Only] Server-defined URL for the resource.
  *   `transferable` (*type:* `boolean()`, *default:* `nil`) - If false, licenses will not be copied from the source resource when creating an image from a disk, disk from snapshot, or snapshot from disk.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :chargesUseFee => boolean() | nil,
          :creationTimestamp => String.t() | nil,
          :description => String.t() | nil,
          :id => String.t() | nil,
          :kind => String.t() | nil,
          :licenseCode => String.t() | nil,
          :name => String.t() | nil,
          :resourceRequirements =>
            GoogleApi.Compute.V1.Model.LicenseResourceRequirements.t() | nil,
          :selfLink => String.t() | nil,
          :transferable => boolean() | nil
        }

  field(:chargesUseFee)
  field(:creationTimestamp)
  field(:description)
  field(:id)
  field(:kind)
  field(:licenseCode)
  field(:name)
  field(:resourceRequirements, as: GoogleApi.Compute.V1.Model.LicenseResourceRequirements)
  field(:selfLink)
  field(:transferable)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.License do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.License.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.License do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
