# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.LocalDisk do
  @moduledoc """


  ## Attributes

  *   `diskCount` (*type:* `integer()`, *default:* `nil`) - Specifies the number of such disks.
  *   `diskSizeGb` (*type:* `integer()`, *default:* `nil`) - Specifies the size of the disk in base-2 GB.
  *   `diskType` (*type:* `String.t`, *default:* `nil`) - Specifies the desired disk type on the node. This disk type must be a local storage type (e.g.: local-ssd). Note that for nodeTemplates, this should be the name of the disk type and not its URL.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :diskCount => integer() | nil,
          :diskSizeGb => integer() | nil,
          :diskType => String.t() | nil
        }

  field(:diskCount)
  field(:diskSizeGb)
  field(:diskType)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.LocalDisk do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.LocalDisk.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.LocalDisk do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
