# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.MachineTypeAccelerators do
  @moduledoc """


  ## Attributes

  *   `guestAcceleratorCount` (*type:* `integer()`, *default:* `nil`) - Number of accelerator cards exposed to the guest.
  *   `guestAcceleratorType` (*type:* `String.t`, *default:* `nil`) - The accelerator type resource name, not a full URL, e.g. 'nvidia-tesla-k80'.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :guestAcceleratorCount => integer() | nil,
          :guestAcceleratorType => String.t() | nil
        }

  field(:guestAcceleratorCount)
  field(:guestAcceleratorType)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.MachineTypeAccelerators do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.MachineTypeAccelerators.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.MachineTypeAccelerators do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
