# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy do
  @moduledoc """


  ## Attributes

  *   `displayName` (*type:* `String.t`, *default:* `nil`) - [Output Only] Deprecated, please use short name instead. The display name of the firewall policy.
  *   `name` (*type:* `String.t`, *default:* `nil`) - [Output Only] The name of the firewall policy.
  *   `rules` (*type:* `list(GoogleApi.Compute.V1.Model.FirewallPolicyRule.t)`, *default:* `nil`) - The rules that apply to the network.
  *   `shortName` (*type:* `String.t`, *default:* `nil`) - [Output Only] The short name of the firewall policy.
  *   `type` (*type:* `String.t`, *default:* `nil`) - [Output Only] The type of the firewall policy.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :displayName => String.t() | nil,
          :name => String.t() | nil,
          :rules => list(GoogleApi.Compute.V1.Model.FirewallPolicyRule.t()) | nil,
          :shortName => String.t() | nil,
          :type => String.t() | nil
        }

  field(:displayName)
  field(:name)
  field(:rules, as: GoogleApi.Compute.V1.Model.FirewallPolicyRule, type: :list)
  field(:shortName)
  field(:type)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
