# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.NodeGroupAutoscalingPolicy do
  @moduledoc """


  ## Attributes

  *   `maxNodes` (*type:* `integer()`, *default:* `nil`) - The maximum number of nodes that the group should have. Must be set if autoscaling is enabled. Maximum value allowed is 100.
  *   `minNodes` (*type:* `integer()`, *default:* `nil`) - The minimum number of nodes that the group should have.
  *   `mode` (*type:* `String.t`, *default:* `nil`) - The autoscaling mode. Set to one of: ON, OFF, or ONLY_SCALE_OUT. For more information, see Autoscaler modes.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :maxNodes => integer() | nil,
          :minNodes => integer() | nil,
          :mode => String.t() | nil
        }

  field(:maxNodes)
  field(:minNodes)
  field(:mode)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.NodeGroupAutoscalingPolicy do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.NodeGroupAutoscalingPolicy.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.NodeGroupAutoscalingPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
