# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.Region do
  @moduledoc """
  Represents a Region resource. A region is a geographical area where a resource is located. For more information, read Regions and Zones.

  ## Attributes

  *   `creationTimestamp` (*type:* `String.t`, *default:* `nil`) - [Output Only] Creation timestamp in RFC3339 text format.
  *   `deprecated` (*type:* `GoogleApi.Compute.V1.Model.DeprecationStatus.t`, *default:* `nil`) - [Output Only] The deprecation status associated with this region.
  *   `description` (*type:* `String.t`, *default:* `nil`) - [Output Only] Textual description of the resource.
  *   `id` (*type:* `String.t`, *default:* `nil`) - [Output Only] The unique identifier for the resource. This identifier is defined by the server.
  *   `kind` (*type:* `String.t`, *default:* `compute#region`) - [Output Only] Type of the resource. Always compute#region for regions.
  *   `name` (*type:* `String.t`, *default:* `nil`) - [Output Only] Name of the resource.
  *   `quotas` (*type:* `list(GoogleApi.Compute.V1.Model.Quota.t)`, *default:* `nil`) - [Output Only] Quotas assigned to this region.
  *   `selfLink` (*type:* `String.t`, *default:* `nil`) - [Output Only] Server-defined URL for the resource.
  *   `status` (*type:* `String.t`, *default:* `nil`) - [Output Only] Status of the region, either UP or DOWN.
  *   `supportsPzs` (*type:* `boolean()`, *default:* `nil`) - [Output Only] Reserved for future use.
  *   `zones` (*type:* `list(String.t)`, *default:* `nil`) - [Output Only] A list of zones available in this region, in the form of resource URLs.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :creationTimestamp => String.t() | nil,
          :deprecated => GoogleApi.Compute.V1.Model.DeprecationStatus.t() | nil,
          :description => String.t() | nil,
          :id => String.t() | nil,
          :kind => String.t() | nil,
          :name => String.t() | nil,
          :quotas => list(GoogleApi.Compute.V1.Model.Quota.t()) | nil,
          :selfLink => String.t() | nil,
          :status => String.t() | nil,
          :supportsPzs => boolean() | nil,
          :zones => list(String.t()) | nil
        }

  field(:creationTimestamp)
  field(:deprecated, as: GoogleApi.Compute.V1.Model.DeprecationStatus)
  field(:description)
  field(:id)
  field(:kind)
  field(:name)
  field(:quotas, as: GoogleApi.Compute.V1.Model.Quota, type: :list)
  field(:selfLink)
  field(:status)
  field(:supportsPzs)
  field(:zones, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.Region do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.Region.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.Region do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
