# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.RegionInstanceGroupManagersListInstanceConfigsResp do
  @moduledoc """


  ## Attributes

  *   `items` (*type:* `list(GoogleApi.Compute.V1.Model.PerInstanceConfig.t)`, *default:* `nil`) - [Output Only] The list of PerInstanceConfig.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - [Output Only] This token allows you to get the next page of results for list requests. If the number of results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the next list request. Subsequent list requests will have their own nextPageToken to continue paging through the results.
  *   `warning` (*type:* `GoogleApi.Compute.V1.Model.RegionInstanceGroupManagersListInstanceConfigsRespWarning.t`, *default:* `nil`) - [Output Only] Informational warning message.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :items => list(GoogleApi.Compute.V1.Model.PerInstanceConfig.t()) | nil,
          :nextPageToken => String.t() | nil,
          :warning =>
            GoogleApi.Compute.V1.Model.RegionInstanceGroupManagersListInstanceConfigsRespWarning.t()
            | nil
        }

  field(:items, as: GoogleApi.Compute.V1.Model.PerInstanceConfig, type: :list)
  field(:nextPageToken)

  field(:warning,
    as: GoogleApi.Compute.V1.Model.RegionInstanceGroupManagersListInstanceConfigsRespWarning
  )
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.RegionInstanceGroupManagersListInstanceConfigsResp do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.RegionInstanceGroupManagersListInstanceConfigsResp.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.RegionInstanceGroupManagersListInstanceConfigsResp do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
