# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.RequestMirrorPolicy do
  @moduledoc """
  A policy that specifies how requests intended for the route's backends are shadowed to a separate mirrored backend service. The load balancer doesn't wait for responses from the shadow service. Before sending traffic to the shadow service, the host or authority header is suffixed with -shadow.

  ## Attributes

  *   `backendService` (*type:* `String.t`, *default:* `nil`) - The full or partial URL to the BackendService resource being mirrored to.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :backendService => String.t() | nil
        }

  field(:backendService)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.RequestMirrorPolicy do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.RequestMirrorPolicy.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.RequestMirrorPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
