# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.ResourceCommitment do
  @moduledoc """
  Commitment for a particular resource (a Commitment is composed of one or more of these).

  ## Attributes

  *   `acceleratorType` (*type:* `String.t`, *default:* `nil`) - Name of the accelerator type resource. Applicable only when the type is ACCELERATOR.
  *   `amount` (*type:* `String.t`, *default:* `nil`) - The amount of the resource purchased (in a type-dependent unit, such as bytes). For vCPUs, this can just be an integer. For memory, this must be provided in MB. Memory must be a multiple of 256 MB, with up to 6.5GB of memory per every vCPU.
  *   `type` (*type:* `String.t`, *default:* `nil`) - Type of resource for which this commitment applies. Possible values are VCPU and MEMORY
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :acceleratorType => String.t() | nil,
          :amount => String.t() | nil,
          :type => String.t() | nil
        }

  field(:acceleratorType)
  field(:amount)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.ResourceCommitment do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.ResourceCommitment.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.ResourceCommitment do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
