# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.ResourcePolicyDailyCycle do
  @moduledoc """
  Time window specified for daily operations.

  ## Attributes

  *   `daysInCycle` (*type:* `integer()`, *default:* `nil`) - Defines a schedule with units measured in days. The value determines how many days pass between the start of each cycle.
  *   `duration` (*type:* `String.t`, *default:* `nil`) - [Output only] A predetermined duration for the window, automatically chosen to be the smallest possible in the given scenario.
  *   `startTime` (*type:* `String.t`, *default:* `nil`) - Start time of the window. This must be in UTC format that resolves to one of 00:00, 04:00, 08:00, 12:00, 16:00, or 20:00. For example, both 13:00-5 and 08:00 are valid.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :daysInCycle => integer() | nil,
          :duration => String.t() | nil,
          :startTime => String.t() | nil
        }

  field(:daysInCycle)
  field(:duration)
  field(:startTime)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.ResourcePolicyDailyCycle do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.ResourcePolicyDailyCycle.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.ResourcePolicyDailyCycle do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
