# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.ResourcePolicyResourceStatus do
  @moduledoc """
  Contains output only fields. Use this sub-message for all output fields set on ResourcePolicy. The internal structure of this "status" field should mimic the structure of ResourcePolicy proto specification.

  ## Attributes

  *   `instanceSchedulePolicy` (*type:* `GoogleApi.Compute.V1.Model.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.t`, *default:* `nil`) - [Output Only] Specifies a set of output values reffering to the instance_schedule_policy system status. This field should have the same name as corresponding policy field.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :instanceSchedulePolicy =>
            GoogleApi.Compute.V1.Model.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.t()
            | nil
        }

  field(:instanceSchedulePolicy,
    as: GoogleApi.Compute.V1.Model.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
  )
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.ResourcePolicyResourceStatus do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.ResourcePolicyResourceStatus.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.ResourcePolicyResourceStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
