# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus do
  @moduledoc """


  ## Attributes

  *   `lastRunStartTime` (*type:* `String.t`, *default:* `nil`) - [Output Only] The last time the schedule successfully ran. The timestamp is an RFC3339 string.
  *   `nextRunStartTime` (*type:* `String.t`, *default:* `nil`) - [Output Only] The next time the schedule is planned to run. The actual time might be slightly different. The timestamp is an RFC3339 string.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :lastRunStartTime => String.t() | nil,
          :nextRunStartTime => String.t() | nil
        }

  field(:lastRunStartTime)
  field(:nextRunStartTime)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
