# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.ScalingScheduleStatus do
  @moduledoc """


  ## Attributes

  *   `lastStartTime` (*type:* `String.t`, *default:* `nil`) - [Output Only] The last time the scaling schedule became active. Note: this is a timestamp when a schedule actually became active, not when it was planned to do so. The timestamp is in RFC3339 text format.
  *   `nextStartTime` (*type:* `String.t`, *default:* `nil`) - [Output Only] The next time the scaling schedule is to become active. Note: this is a timestamp when a schedule is planned to run, but the actual time might be slightly different. The timestamp is in RFC3339 text format.
  *   `state` (*type:* `String.t`, *default:* `nil`) - [Output Only] The current state of a scaling schedule.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :lastStartTime => String.t() | nil,
          :nextStartTime => String.t() | nil,
          :state => String.t() | nil
        }

  field(:lastStartTime)
  field(:nextStartTime)
  field(:state)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.ScalingScheduleStatus do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.ScalingScheduleStatus.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.ScalingScheduleStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
