# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.ShareSettings do
  @moduledoc """
  The share setting for reservations and sole tenancy node groups.

  ## Attributes

  *   `projectMap` (*type:* `%{optional(String.t) => GoogleApi.Compute.V1.Model.ShareSettingsProjectConfig.t}`, *default:* `nil`) - A map of project id and project config. This is only valid when share_type's value is SPECIFIC_PROJECTS.
  *   `shareType` (*type:* `String.t`, *default:* `nil`) - Type of sharing for this shared-reservation
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :projectMap =>
            %{optional(String.t()) => GoogleApi.Compute.V1.Model.ShareSettingsProjectConfig.t()}
            | nil,
          :shareType => String.t() | nil
        }

  field(:projectMap, as: GoogleApi.Compute.V1.Model.ShareSettingsProjectConfig, type: :map)
  field(:shareType)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.ShareSettings do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.ShareSettings.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.ShareSettings do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
