# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.SslCertificateManagedSslCertificate do
  @moduledoc """
  Configuration and status of a managed SSL certificate.

  ## Attributes

  *   `domainStatus` (*type:* `map()`, *default:* `nil`) - [Output only] Detailed statuses of the domains specified for managed certificate resource.
  *   `domains` (*type:* `list(String.t)`, *default:* `nil`) - The domains for which a managed SSL certificate will be generated. Each Google-managed SSL certificate supports up to the [maximum number of domains per Google-managed SSL certificate](/load-balancing/docs/quotas#ssl_certificates).
  *   `status` (*type:* `String.t`, *default:* `nil`) - [Output only] Status of the managed certificate resource.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :domainStatus => map() | nil,
          :domains => list(String.t()) | nil,
          :status => String.t() | nil
        }

  field(:domainStatus, type: :map)
  field(:domains, type: :list)
  field(:status)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.SslCertificateManagedSslCertificate do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.SslCertificateManagedSslCertificate.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.SslCertificateManagedSslCertificate do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
