# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.VpnGatewayStatusHighAvailabilityRequirementState do
  @moduledoc """
  Describes the high availability requirement state for the VPN connection between this Cloud VPN gateway and a peer gateway.

  ## Attributes

  *   `state` (*type:* `String.t`, *default:* `nil`) - Indicates the high availability requirement state for the VPN connection. Valid values are CONNECTION_REDUNDANCY_MET, CONNECTION_REDUNDANCY_NOT_MET.
  *   `unsatisfiedReason` (*type:* `String.t`, *default:* `nil`) - Indicates the reason why the VPN connection does not meet the high availability redundancy criteria/requirement. Valid values is INCOMPLETE_TUNNELS_COVERAGE.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :state => String.t() | nil,
          :unsatisfiedReason => String.t() | nil
        }

  field(:state)
  field(:unsatisfiedReason)
end

defimpl Poison.Decoder,
  for: GoogleApi.Compute.V1.Model.VpnGatewayStatusHighAvailabilityRequirementState do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.VpnGatewayStatusHighAvailabilityRequirementState.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Compute.V1.Model.VpnGatewayStatusHighAvailabilityRequirementState do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
