# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Compute.V1.Model.VpnGatewayStatusTunnel do
  @moduledoc """
  Contains some information about a VPN tunnel.

  ## Attributes

  *   `localGatewayInterface` (*type:* `integer()`, *default:* `nil`) - The VPN gateway interface this VPN tunnel is associated with.
  *   `peerGatewayInterface` (*type:* `integer()`, *default:* `nil`) - The peer gateway interface this VPN tunnel is connected to, the peer gateway could either be an external VPN gateway or GCP VPN gateway.
  *   `tunnelUrl` (*type:* `String.t`, *default:* `nil`) - URL reference to the VPN tunnel.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :localGatewayInterface => integer() | nil,
          :peerGatewayInterface => integer() | nil,
          :tunnelUrl => String.t() | nil
        }

  field(:localGatewayInterface)
  field(:peerGatewayInterface)
  field(:tunnelUrl)
end

defimpl Poison.Decoder, for: GoogleApi.Compute.V1.Model.VpnGatewayStatusTunnel do
  def decode(value, options) do
    GoogleApi.Compute.V1.Model.VpnGatewayStatusTunnel.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Compute.V1.Model.VpnGatewayStatusTunnel do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
